#import <Cocoa/Cocoa.h>
#import <OpenGL/GL.h>
#import <OpenGL/GLu.h>
#import <QuickTime/QuickTimeComponents.h>

#import "XeeImage.h"

#define XeeBitmapTypeLuma8 1
#define XeeBitmapTypeYUV422 2
#define XeeBitmapTypeRGB24 3
#define XeeBitmapTypeARGB32 4
#define XeeBitmapTypeBGRA32 5



@class XeeBitmapTile;

@interface XeeBitmapImage:XeeImage
{
	int type,bytesperrow,pixelsize;
	BOOL premultiplied;

	void *data;
	BOOL freedata;

	GLuint textarget,texintformat,texformat,textype;

	GWorldPtr gw;
	NSBitmapImageRep *imagerep;

	NSMutableArray *tiles;
	BOOL needsupdate;
	NSOpenGLContext *context;
}

-(id)initWithFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes;
-(id)initWithType:(int)pixeltype width:(int)framewidth height:(int)frameheight;
-(id)initWithData:(void *)pixeldata type:(int)pixeltype width:(int)framewidth height:(int)frameheight bytesPerRow:(int)bprow;
-(id)initWithImageRep:(NSBitmapImageRep *)rep;

-(void)dealloc;

-(void)setData:(void *)data type:(int)type width:(int)framewidth height:(int)frameheight bytesPerRow:(int)bprow;
-(BOOL)allocBitmapWithType:(int)pixeltype width:(int)framewidth height:(int)frameheight;
-(void)setPremultiplied:(BOOL)pre;

-(NSBitmapImageRep *)imageRep;
-(GWorldPtr)gworld;

-(void)triggerUpdateAction;

-(void)draw:(NSPoint)point size:(NSSize)size bounds:(NSRect)bounds;
-(void)allocTexturesRect;
-(void)allocTextures2D;
-(void)loadTextures;

-(void)fixYUVGamma;

-(int)type;
-(int)bytesPerRow;
-(void *)data;

@end

@interface XeeBitmapTile:NSObject
{
	int x,y;
	int width,height;
	float texwidth,texheight;

	GLuint tex;
}

-(id)initWithTarget:(GLuint)textarget x:(int)x0 y:(int)y0 width:(int)w height:(int)h texwidth:(float)tw texheight:(float)th;
-(void)loadWithTarget:(GLuint)textarget internalFormat:(GLuint)texintformat format:(GLuint)texformat type:(GLuint)textype data:(void *)data;
-(void)drawWithTarget:(GLuint)textarget bounds:(NSRect)bounds;

@end

