#import <Cocoa/Cocoa.h>

#define XeeNoMode 0
#define XeeMoveMode 1
#define XeeCopyMode 2

@class XeeImage,XeeView;

@interface XeeController:NSObject
{
	XeeImage *currimage;
	float zoom;

	IBOutlet NSWindow *window;
    IBOutlet XeeView *imageview;
    IBOutlet NSTextField *statusbar;
}

-(id)init;
-(void)dealloc;
-(void)windowWillClose:(NSNotification *)notification;
-(void)windowWillMiniaturize:(NSNotification *)notification;
-(void)windowDidMiniaturize:(NSNotification *)notification;

-(void)setImage:(XeeImage *)image;
-(void)imageUpdated:(XeeImage *)image;

-(void)setZoom:(float)newzoom;
-(void)setFrame:(int)frame;

-(void)setViewSize:(NSSize)size;
-(NSSize)maxViewSize;
-(NSSize)minViewSize;
-(NSRect)availableScreenSpace;

-(void)updateStatusBar;

-(NSWindow *)window;

-(void)copy:(id)sender;
-(void)saveImage:(id)sender;

-(IBAction)frameSkipNext:(id)obj;
-(IBAction)frameSkipPrev:(id)obj;
-(IBAction)animationToggle:(id)obj;

-(IBAction)zoomIn:(id)sender;
-(IBAction)zoomOut:(id)sender;
-(IBAction)zoomActual:(id)sender;
-(IBAction)zoomFit:(id)sender;
//-(IBAction)fullScreen:(id)sender

@end
